aboutsummaryrefslogtreecommitdiffstats
path: root/home-manager/packages/scripts/small_functions/update
diff options
context:
space:
mode:
authorSoispha <soispha@vhack.eu>2023-04-15 14:46:57 +0200
committerSoispha <soispha@vhack.eu>2023-05-09 19:30:41 +0200
commit1d99a83ff46f0877d873a26300a58f44758936bb (patch)
tree3898d37e4a78f66df098f428ba717ea9cdfa8ab4 /home-manager/packages/scripts/small_functions/update
parentFix(hm/pkgs/scr/update): Reset branch after update (diff)
downloadnixos-config-1d99a83ff46f0877d873a26300a58f44758936bb.zip
Fix(hm/pkgs/scr/update): Add grep and sed as dependencies
Diffstat (limited to 'home-manager/packages/scripts/small_functions/update')
-rwxr-xr-xhome-manager/packages/scripts/small_functions/update53
1 files changed, 53 insertions, 0 deletions
diff --git a/home-manager/packages/scripts/small_functions/update b/home-manager/packages/scripts/small_functions/update
new file mode 100755
index 00000000..e4cdbdfd
--- /dev/null
+++ b/home-manager/packages/scripts/small_functions/update
@@ -0,0 +1,53 @@
+#!/usr/bin/env dash
+# shellcheck disable=SC2086
+# shellcheck source=/dev/null
+. %SHELL_LIBRARY_PATH
+
+help() {
+ cat << EOF
+ This is an Nixos flake update manager.
+
+ Usage:
+ "$name" [--branch <branchname>] [--help]
+
+ Options:
+ --branch | -b [branchname] select a branch to update from.
+ --help | -h output this help.
+EOF
+ exit "$1";
+}
+name="$0";
+[ "$name" = "" ] && name=update;
+tmp=$(mktmp);
+git remote show origin | grep 'HEAD' | cut -d':' -f2 | sed -e 's/^ *//g' -e 's/ *$//g' > $tmp &
+BRANCH="";
+
+while [ "$#" -gt 0 ];do
+ case "$1" in
+ "--help" | "-h")
+ help 0;
+ ;;
+ "--branch" | "-b")
+ if [ -n "$2" ];then
+ BRANCH="$2";
+ else
+ error "$1 requires an argument";
+ help 1;
+ fi
+ shift 2;
+ ;;
+ *)
+ error "the option $1 does not exist!";
+ help 1;
+ ;;
+ esac
+done
+
+
+cd /etc/nixos || die "No /etc/nixos"
+git pull --rebase
+[ "$BRANCH" = "" ] || git switch "$BRANCH";
+nixos-rebuild switch
+git switch "$(cat $tmp)";
+
+# vim: ft=sh